package com.badbuta.learnspringbootrestfulsqlite;

import org.springframework.web.bind.annotation.RestController;

import com.badbuta.learnspringbootrestfulsqlite.entities.User;
import com.badbuta.learnspringbootrestfulsqlite.services.UserService;
import org.springframework.web.bind.annotation.RequestMapping;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

/**
 * The RESTful API Controller Class
 * The URL for this API Controller is '/api/v1'
 * 
 * NOTE: By adding @CrossOrigin, Swagger preview can work perfectly.
 * 
 */
@RestController
@CrossOrigin
@RequestMapping(value = "/api/v1")
public class UserController {
    @Autowired
    private UserService userService;

    /**
     * Get the user(s) by id (using query-string param)
     * 
     * @param id The ID for
     * @return User object in JSON
     */
    @GetMapping(value = "users", produces = "application/json")
    public List<User> getUsers() {
        List<User> users = userService.getUsers();
        return users;

    }

    @GetMapping(value = "users/{id}", produces = "application/json")
    public User getUsersById(@PathVariable("id") String userId) {
        User user = userService.getUserById(Integer.parseInt(userId));
        return user;

    }

    @PostMapping("users")
    public User insertUser(@RequestBody User user) {
        // TODO: Return always 1, need to fix
        int id = userService.insertUser(user);
        user.setId(id);
        return user;
    }

}
